Redmine - Patch #31110

Raise an exception if the plugin directory name differs from the plugin id
Description

If the plugin directory name and the plugin id are not the same, the plugin will not work because the required files will not be read.

Example:

If you change the directory name of redmine_vividtone_my_page_blocks plugin to redmine-vividtone-my-page-blocks, the following
log will be output and it will not work well.

Partial "my/blocks/new_issues" missing for block "new_issues" found in admin (id=1) preferences
Partial "my/blocks/neglected_issues" missing for block "neglected_issues" found in admin (id=1) pr
eferences

Partial "my/blocks/doing_issues" missing for block "doing_issues" found in admin (id=1) preference
s

The problem is hard to solve because you can not notice that the wrong directory name is the cause of the problem.

I think | should raise an exception if there is no directory with the same name as the plugin id.
| attached a patch for that.

Related issues:
Related to Redmine - Feature #31538: Allow a plugin to be installed in the di... New

Associated revisions

Revision 18063 - 2019-04-19 17:23 - Go MAEDA

Fix plugins test to use correct plugin name and directory (#31110).

Patch by Mizuki ISHIKAWA.

Revision 18064 - 2019-04-19 17:30 - Go MAEDA

Raise an exception if the plugin directory name differs from the plugin id (#31110).
Patch by Mizuki ISHIKAWA.

Revision 18065 - 2019-04-20 01:42 - Go MAEDA
Add a plugin for test (#31110).

Revision 18152 - 2019-05-10 02:41 - Go MAEDA
Fix a failing test (#31110).

PluginTest fails if Redmine is cloned from GitHub because Git ignores the empty other_plugin directory.

This file had to be committed in r18063.

History

#1 - 2019-03-28 08:09 - Mizuki ISHIKAWA
- File 0001-Fix-test-not-to-raise-exception.patch added

- File 0002-Change-to-raise-an-exception.patch added

2025-05-17 1/3



https://github.com/vividtone/redmine_vividtone_my_page_blocks

| forgot to attach a patchll[l

#2 - 2019-03-28 08:47 - Go MAEDA

- Target version set to Candidate for next major release

Thank you for posting the patch. | think it would be even better if the exception has a more informative message like the following. With this message,
an admin easily understands that he should rename the directory.

Plugin not found. The plugin #{p.id} should be installed in #{p.directory}.

#3 - 2019-04-01 15:54 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

#4 - 2019-04-09 03:28 - Mizuki ISHIKAWA
- File 0002-Change-to-raise-an-exception-v2.patch added

| corrected the error message to include the directory name.

#5 - 2019-04-12 13:46 - Akiko Takano

+1 Nice work, quite helpful!

#6 - 2019-04-19 17:31 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA
Committed the patches. Thank you for your contribution.

#7 - 2019-06-09 05:44 - Go MAEDA
- Related to Feature #31538: Allow a plugin to be installed in the directory different from the plugin id added

#8 - 2022-07-05 21:29 - luigifab !
Since the following piece of code was added:
unless File.directory? (p.directory)

raise PluginNotFound, "Plugin not found. The directory for plugin #{p.id} should be #{p.directory}."
end

This prevent Redmine plugins packed into Gem (example https:/rubygems.org/gems/redmine_apijs for Redmine < 5) to work with Redmine 4.1+. It
was working with Redmine 3.x and 4.0.

By removing it, this work with Redmine 4.1 /4.2/5.0.
#9 - 2022-07-21 03:17 - Mizuki ISHIKAWA
luigifab ! wrote:
Since the following piece of code was added:
(-]

This prevent Redmine plugins packed into Gem (example https:/rubygems.org/gems/redmine_apijs for Redmine < 5) to work with Redmine
4.1+. It was working with Redmine 3.x and 4.0.

By removing it, this work with Redmine 4.1 /4.2 /5.0.

Thanks for sharing the issue.
The exception occurred because the plugin directory is located in /usr/local/bundle/gems/redmine_apijs-6.9.0 when using the redmine_apijs plugin as
you mentioned.

#10 - 2022-07-21 03:31 - Go MAEDA

luigifab ! wrote:

Since the following piece of code was added:
(-]

This prevent Redmine plugins packed into Gem (example https:/rubygems.org/gems/redmine_apijs for Redmine < 5) to work with Redmine

4.1+. It was working with Redmine 3.x and 4.0.

By removing it, this work with Redmine 4.1 /4.2 /5.0.

Since this issue is closed and the change has already been delivered, please open a new issue.

Files

0001-Fix-test-not-to-raise-exception.patch 9.91 KB 2019-03-28 Mizuki ISHIKAWA
0002-Change-to-raise-an-exception.patch 1.75 KB 2019-03-28 Mizuki ISHIKAWA
0002-Change-to-raise-an-exception-v2.patch 1.83 KB 2019-04-09 Mizuki ISHIKAWA
